(* -------------------------------------------------- *)
(* TCPhrase -- Delphi wJk  Ver. 0.91
(* @: F(Wolfgang Chien)
(* Mail: wolfgang@ms2.hinet.net
(* WWW: http://www.geocities.com/~wchien
(*
(* 1. b涥qݭn CPhrase.tbl, ӳQTm
(*    b Windows 95 w˥ؿ
(*
(* 2. CPhrase.tbl igѥ MakePhrase k.
(*    ӤknDǤJw/媺ɮצW(t|),
(*    Yͦ\, ӨƶǦ^ True.
(*
(* 3. w/大rɳWpU:
(*    1)@몺r, ig pe2  Os貣
(*    2)CC1-8欰, ĤE}lܸӦ浲
(*      dҥiѦҥYɤ Sample.TXT
(*    3)䬰rФ@ߤjg
(*    4)iΧ@䪺r 0..9, A..B, `-=[;'],./\
(*      Ӥwg[\jJkrګ
(* -------------------------------------------------- *)
unit CPhrase;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  cPhsUI;

type
  TCPhrase = class(TComponent)
  private
    { Private declarations }
    bEnabled: Boolean;
    hPhraseFile: integer;
    iCacheSize: longint;
    procedure SetEnabled(bValue: boolean);
    function FindPhraseFile: boolean;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function MakePhrase(const sInputFileName: string): boolean;
  published
    { Published declarations }
    property Enabled: boolean read bEnabled write SetEnabled default False;
  end;

procedure Register;

implementation

var
  hNextKBHookProc: HHook;
  hNextCBTHookProc: HHook;
  sPhraseFileName: string;

(* -------------------------------------------------- *)
(*
(*
(*
(* -------------------------------------------------- *)
procedure Register;
begin
  RegisterComponents('Samples', [TCPhrase]);
end;

(* -------------------------------------------------- *)
(*
(*
(*
(* -------------------------------------------------- *)
constructor TCPhrase.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  frmUI := nil;
  bEnabled := False;
  hFocusControl := 0;
  hNextKBHookProc := 0;
  hNextCBTHookProc := 0;
  bPhsTemp := False;
  bPhsKeep := False;
end;

(* -------------------------------------------------- *)
(*
(*
(*
(* -------------------------------------------------- *)
destructor TCPhrase.Destroy;
begin
  Enabled := False;
  inherited Destroy;
end;

(* -------------------------------------------------- *)
(*
(*
(*
(* -------------------------------------------------- *)
function KeyboardHookHandler(iCode: Integer;
  wParam: WPARAM;
  lParam: LPARAM): LRESULT; stdcall; export;
begin
  Result := 0;
  If iCode < 0 Then
  begin
    Result := CallNextHookEx(hNextKBHookProc, iCode, wParam, lParam);
    Exit;
  end;
  if GetKeyState(VK_Control) < 0 then Exit;
  if GetKeyState(VK_SHIFT) < 0 then Exit;

  if GetKeyState(VK_F12) < 0 then
  begin
    if frmUI = nil then
    begin
      frmUI := TfrmUI.Create(Application);
      frmUI.Init(sPhraseFileName);
    end;

    Result := 1;
    if bPhsKeep then
      frmUI.Show
    else
    begin
      if frmUi.Visible then
        frmUI.Hide
      else
        frmUI.Show;
    end;
    bPhsTemp := frmUI.Visible;
    bPhsKeep := False;
    Windows.SetFocus(hFocusControl);
    Exit;
  end;

  if GetKeyState(VK_F11) < 0 then
  begin
    if frmUI = nil then
    begin
      frmUI := TfrmUI.Create(Application);
      frmUI.Init(sPhraseFileName);
    end;

    Result := 1;
    if bPhsTemp then
      frmUI.Show
    else
    begin
      if frmUi.Visible then
        frmUI.Hide
      else
        frmUI.Show;
    end;
    bPhsTemp := False;
    bPhsKeep := frmUI.Visible;
    Windows.SetFocus(hFocusControl);
    Exit;
  end;

  if frmUI <> nil then
    if frmUI.Visible then
      if frmUI.DoKeyEvent(wParam, lParam) then
        Result := 1;
end;

(* -------------------------------------------------- *)
(*
(*
(*
(* -------------------------------------------------- *)
function CBTHookHandler(iCode: Integer;
  wParam: WPARAM;
  lParam: LPARAM): LRESULT stdcall; export;
begin
  Result := 0;
  If iCode < 0 Then
  begin
    Result := CallNextHookEx(hNextCBTHookProc, iCode, wParam, lParam);
    Exit;
  end;
  if iCode = HCBT_SETFOCUS then
  begin
    if frmUI = nil then hFocusControl := wParam
    else
      if not frmUI.IsUIComponent(wParam) then hFocusControl := wParam;
  end;
end;

(* -------------------------------------------------- *)
(*
(*
(*
(* -------------------------------------------------- *)
function TCPhrase.FindPhraseFile: boolean;
var
  szWindowDir: array[0..254] of char;
begin
  Result := False;
  if GetWindowsDirectory(szWindowDir, 254) > 0 then
  begin
    sPhraseFileName := StrPas(szWindowdir);
    if sPhraseFileName[Length(sPhraseFileName)] <> '\' then
      AppendStr(sPhraseFileName, '\' + 'CPHRASE.TBL')
    else
      AppendStr(sPhraseFileName, 'CPHRASE.TBL');
    if FileExists(sPhraseFileName) then
      Result := True
    else
    begin
      // sPhraseFileName := '';
      MessageBeep(0);
      Windows.MessageBox(0, 'bWindoww˥ؿ䤣w(CPhrase.TBL)',
        '~i', 48);
    end;
  end
  else
    sPhraseFileName := '';
end;

(* -------------------------------------------------- *)
(*
(*
(*
(* -------------------------------------------------- *)
procedure TCPhrase.SetEnabled(bValue: boolean);
begin
  if bEnabled = bValue then Exit;
  if bValue then
  begin
    hFocusControl := GetFocus;
    if not FindPhraseFile then
    begin
      bEnabled := False;
      Exit;
    end;
    if csDesigning in ComponentState then
    begin
      bEnabled := bValue;
      Exit;
    end;

    (* W WH_KEYBOARD P WH_CBT o⫬ HOOK; *)
    hNextKBHookProc := SetWindowsHookEx(WH_KEYBOARD,
      KeyboardHookHandler,
      HInstance,
      0);
    hNextCBTHookProc := SetWindowsHookEx(WH_CBT,
      CBTHookHandler,
      HInstance,
      0);
    bEnabled := (hNextKBHookProc <> 0) and (hNextCBTHookProc <> 0);
  end
  else
  begin
    if csDesigning in ComponentState then
    begin
      bEnabled := bValue;
      Exit;
    end;
    if not (csDestroying in ComponentState) then
    begin
      if frmUI <> nil then
      begin
        frmUi.Free;
        frmUI := nil;
      end;
    end;
    if hNextKBHookProc <> 0 then
    begin
      UnhookWindowshookEx(hNextKBHookProc);
      hNextKBHookProc := 0;
      MessageBeep(0);
    end;
    if hNextCBTHookProc <> 0 then
    begin
      UnhookWindowshookEx(hNextCBTHookProc);
      hNextKBHookProc := 0;
      MessageBeep(0);
    end;
    bEnabled := bValue;
  end;
  bPhsTemp := False;
  bPhsKeep := False;
end;


(* -------------------------------------------------- *)
(* Hwr(???.txt)صw(CPhrase.TBL)
(*
(*
(* -------------------------------------------------- *)
function TCPhrase.MakePhrase(const sInputFileName: string): boolean;
var
  fInput: TextFile;
  fOutput: integer;
  sInput: string;
  sOutput: string;
  szOutput: array[0..254] of char;
  bKeepEnabled: boolean;
begin
  Result := False;
  if not FileExists(sInputFileName) then Exit;
  bKeepEnabled := Enabled;
  Enabled := False;
  if Enabled then
  begin
    bEnabled := False;
    Exit;
  end;
  FindPhraseFile;
  IF sPhraseFileName = '' then Exit;

  AssignFile(fInput, sInputFileName);
  FileMode := 0; { read only }
  Reset(fInput);

  fOutput := FileCreate(sPhraseFileName);
  while not Eof(fInput) do
  begin
    ReadLn(fInput, sInput);
    sOutput := Trim(Copy(sInput, 1, _KeySize)) + #10 +
      Trim(Copy(sInput, _KeySize + 1, Length(sInput) - _KeySize)) + #13;
    FileWrite(fOutput, pchar(sOutput)^, Length(sOutput));
  end;

  CloseFile(fInput);
  FileClose(fOutput);
  Enabled := bKeepEnabled;
  Result := True;
end;

end.

